package puppet;



import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.StringWriter;
import java.util.Vector;

import org.apache.axis.utils.XMLUtils;

import org.apache.axis.deployment.wsdd.*;
import org.w3c.dom.Element;
import org.apache.xerces.parsers.DOMParser;

public class WSDD_Parser 
{
	public WSDD_Parser()
	{}
	
	/* ParseWsdd prende in input un array di servizi, il wsdd e restituisce
	 * il percorso del file in cui il servizio � stato implementato
	 * fname="/Users/Aran/Documents/Tirocinio/Documentazione/Aran/deploy.wsdd";
	 * all'interno di questa funzione vengono eseguite le seguenti azioni:
	 * 1)Per ogni GuaranteeTerms viene parsato il ServiceScope alla ricerca delle funzioni selezionate
	 * 2)Attraverso il file wsdd viene individuato il file java in cui � mappato il servizio precedentemente
	 *   trovato/i nel ServiceScope
	 * 3)Viene inserito all'interno dell'oggetto che si ritorna i dati necessari al completamento
	 *   delle funzioni previste da questo programma
	
	*/
	public  static Vector Parse_WSDD(String fname,String[] ListaServizidaMappare)
	{
		System.out.println("WSDD");
		WSDDDocument WSDDDoc=null;
		WSDDService service[] = null;
		//Faccio il parsing del WSDD con un oggetto DOM
		DOMParser parser = new DOMParser();
		Vector ElencoServizi = new Vector();
		String WSDDServizio = "";
		ServiceObj SObj=null;
		try 
		{
			parser.parse(fname);
		} 
		catch (Exception ioe) 
		{ 	System.out.println("WSDD_Parser: Parse_WSDD "+ioe); }
		//Estraggo l'elemento da dom e creo un oggetto WSDD
		Element elem = parser.getDocument().getDocumentElement();
		try
		{
			WSDDDoc = new WSDDDocument(elem);
		}
		catch(Exception e)
		{System.out.println("WSDD_Parser: Parse_WSDD "+e);}
		service = WSDDDoc.getDeployment().getServices();
		//String[] elencoServizi= new String [service.length];
		try
		{
			for(int z=0;z<ListaServizidaMappare.length;z++)
			{
				for(int i=0;i<service.length;i++)
				{
					WSDDServizio = service[i].getQName().toString();

					if(ListaServizidaMappare[z].equals(WSDDServizio))
					{
						//---------------------------

						WSDDServizio = service[i].getQName().toString();			
						//System.out.println("WSDD_Parser"+ListaServizidaMappare[z]);
						String classname=service[i].getParameter("className");
						
						classname = classname.replaceFirst("Skeleton","Impl");
						service[i].setParameter("className",classname);
						StringWriter writer = new StringWriter();
				        XMLUtils.DocumentToWriter(WSDDDoc.getDOMDocument(), writer);
				        writer.close();
				        //System.out.println("***************************"+writer.toString());  // visualizza la riga 

				        File f=new File(fname);
				        FileOutputStream fos=new FileOutputStream(f);
				        PrintStream ps=new PrintStream(fos);
				        ps.println(writer.toString());
				        fos.close();  // chiude il file 
						//---------------------------	
						//System.out.println("WSDD_Parser"+ListaServizidaMappare[z]);
						String servicename =service[i].getQName().toString();
						classname= classname.replace(".", "/");
						//nel wsdd c'� scritto il file java corrispondente allo skeleton
						//il nostro intento � di andare a scrivere all'interno del file che implementa
						//il servizio quindi alla stringa in fondo va tolto "Skeleton" ed inserito "Impl"
						//System.out.println("WSDD_Parser"+classname);
						classname=classname+".java";							
						SObj = new ServiceObj(servicename,classname);
						
						ElencoServizi.add(SObj);
						
					}
				}
			}
		}catch(Exception e){System.out.println("WSDD_Parser"+e);}

		//System.out.println(filename);
		return ElencoServizi;
	}
}
