package puppet.commonFeatures;

import java.io.File;
import puppet.Support;

public class CommonFeatures {

    private String serviceLocation;
    private String serviceWSDLPath;   
    private String serviceClassName;   
    private Support puppetFacilities;
    private String content;
    
    public CommonFeatures(String serviceLocation, String serviceWSDLPath){
        this.serviceLocation = serviceLocation;
        this.serviceWSDLPath = serviceWSDLPath;
        this.puppetFacilities = new Support();
        this.content = puppetFacilities.GetJavaSource(serviceLocation);
        
//      This variable is it used just to extract the serviceClassName
           File dummyFile = new File(serviceLocation);
           String tempBuffer = dummyFile.getName();
//      The extrension string ".java" has 5 characters    
           this.serviceClassName = tempBuffer.substring(0, tempBuffer.length()-5);        
    }
    
    /*
     * Actually adds the Common Statements to the code
     */    
        public String parse (){
            CommonClassCodeProcessor commonFeaturesProcessor = new CommonClassCodeProcessor(this.serviceClassName,this.serviceWSDLPath);
            System.out.println("+++++++++++++++++++++++++");
            String sourceCodeWithMobility = commonFeaturesProcessor.parseClass(content);
            return sourceCodeWithMobility;
          }

   /*
    * Actually adds the Common Statements to the code and dump it on the file systems
    */    
        public void parseAndDump (){
            CommonClassCodeProcessor commonFeaturesProcessor = new CommonClassCodeProcessor(this.serviceClassName,this.serviceWSDLPath);
            System.out.println("+++++++++++++++++++++++++");
            String sourceCodeWithMobility = commonFeaturesProcessor.parseClass(content);
            puppetFacilities.PutJavaSource(serviceLocation,sourceCodeWithMobility);                
          }
            
        public String getServiceLocation() {
            return serviceLocation;
        }
}
