package puppet.commonFeatures;

public class CommonPatternsReader {

    protected String invocationTimeVarName;
    protected String returnValueVarName;
    protected String varPrefixName;

    public CommonPatternsReader (){        
        this.invocationTimeVarName = "invocationTime";
        this.returnValueVarName = "returnValue";
        this.varPrefixName = "commonPrefix";
    }
    
    public CommonPatternsReader (String varPrefixName){        
        this();
        this.varPrefixName = varPrefixName;
    }

    public CommonPatternsReader (String invocationTimeVarName, String returnValueVarName){        
        this();
        this.invocationTimeVarName = invocationTimeVarName;
        this.returnValueVarName = returnValueVarName;
    }

    public CommonPatternsReader (String varPrefixName, String invocationTimeVarName, String returnValueVarName){        
        this(invocationTimeVarName,returnValueVarName);
        this.varPrefixName = varPrefixName;
    }

    public String getExceptionStatements (){
        return " throws Exception ";    
     }
    
    public String getCommonVariableCode(String methodReturnType){
        String varCode;
//      that's a bug!! the \\ are required since it is invoked by a String.repalceFirst 
//      method whose will crash without them because of the $s        
         varCode = "long \\$" + this.varPrefixName +"\\$" + invocationTimeVarName + " = 0; \n"; 
        return varCode; 
    }

    public String castExceptions(String codeToCast, String exceptionName){
        return "try { \n " + codeToCast + " \n } catch (Exception genericException ){ \n throw new "+ exceptionName +"(genericException.getMessage()); \n } \n";
    }

    public String getElapsedTimeStatement(){
        return " - \\$" + this.varPrefixName +"\\$"+invocationTimeVarName+" - System.currentTimeMillis()";
    }
    
    public String getCurrentTimeStampStatements (){        
//      that's a bug!! the \\ are required since it is invoked by a String.repalceFirst 
//      method whose will crash without them because of the $s        
        return "\\$" + this.varPrefixName +"\\$" + invocationTimeVarName + " = System.currentTimeMillis(); ";        
    }

    public String getReturnValueVarName() {
        return returnValueVarName;
    }

    public String getInvocationTimeVarName() {
        return invocationTimeVarName;
    }
    
}
