package puppet.mobility.oracle;

import java.text.ParseException;

public class SimulatedEvent {
    
    private String nodeName;
    private EventsType event;    
    /*
     *  In Seconds
     */    
    private double simulationTime;
    private NodePosition position;
    
    public SimulatedEvent (String traceLine) throws ParseException{
        
        String[] traceLineContents = traceLine.split("\\s");
                
        this.event = this.convertEventType(traceLineContents[Constants4Mobility.EVENT_POSITION_IN_TRACELINE]);
        
        if (this.event.compareTo(EventsType.MOVEMENT) == 0)
            throw new ParseException("This input is not formatted as an NS2 event: " + traceLine,0);
        
        this.nodeName = traceLineContents[Constants4Mobility.NODENAME_POSITION_IN_TRACELINE];
//      this.nodeName = this.convertNodeName(traceLineContents[Constants4Mobility.NODENAME_POSITION_IN_TRACELINE]);
        this.simulationTime = Double.parseDouble(traceLineContents[Constants4Mobility.SIMULATION_TIME_POSITION_IN_TRACELINE]);
        
        double x = Double.parseDouble(traceLineContents[Constants4Mobility.NODE_COORDINATE_X_POSITION_IN_TRACELINE]); 
        double y = Double.parseDouble(traceLineContents[Constants4Mobility.NODE_COORDINATE_Y_POSITION_IN_TRACELINE]);
        double z = Double.parseDouble(traceLineContents[Constants4Mobility.NODE_COORDINATE_Z_POSITION_IN_TRACELINE]);            
        this.position = new NodePosition(x,y,z);
    }

    /*
     * This method shoul be useless!!
     */
    private String convertNodeName(String unprocessedNodeName) {
        return unprocessedNodeName.substring(1, unprocessedNodeName.length()-1);
    }

    private EventsType convertEventType(String unprocessedEvent) throws EnumConstantNotPresentException{
        if (unprocessedEvent.equalsIgnoreCase("s"))
            return EventsType.SEND;
        if (unprocessedEvent.equalsIgnoreCase("r"))
            return EventsType.RECEIVE;
        if (unprocessedEvent.equalsIgnoreCase("d"))
            return EventsType.DROP;
        if (unprocessedEvent.equalsIgnoreCase("f"))
            return EventsType.FORWARD;  
        if (unprocessedEvent.equalsIgnoreCase("m"))
            return EventsType.MOVEMENT;  

        throw new EnumConstantNotPresentException(EventsType.class,unprocessedEvent);
    }
    
    public EventsType getEvent() {
        return event;
    }

    public String getNodeName() {
        return nodeName;
    }

    public double getSimulationTime() {
        return simulationTime;
    }

    public NodePosition getPosition() {
        return position;
    }

}
