package puppet.mobility.oracle;


public class TraceReader extends AbstractTraceReader{

    private static boolean existsAnInstance;
        
    public TraceReader(){
        super(Constants4Mobility.DEFAULT_CONFIGURATION_FILENAME);          
    }

    public TraceReader(String traceFilename){
        super(traceFilename);          
    }
    
    @Override
    protected boolean metricIsVisible(SimulatedEvent a, SimulatedEvent b) {
//        return (euclidianDistrance(a.getPosition(), b.getPosition()) < Constants4Mobility.DEFAULT_MAX_RADIUS);        
        return (euclidianDistrance(a.getPosition(), b.getPosition()) < this.maxRadius);        
    }
   
    @Override
    protected double metricDampEffect (SimulatedEvent a, SimulatedEvent b) {
//        double returnValue = euclidianDistrance(a.getPosition(), b.getPosition()) / Constants4Mobility.DEFAULT_MAX_RADIUS; 
        double returnValue = euclidianDistrance(a.getPosition(), b.getPosition()) / this.maxRadius; 
        if ( returnValue < 1)
            return returnValue;
        return 1;        
    }

    private double euclidianDistrance (NodePosition a, NodePosition b){        
        double xAxis = (Math.pow(a.getX()-b.getX(),2));
        double yAxis = (Math.pow(a.getY()-b.getY(),2));
        double zAxis = (Math.pow(a.getZ()-b.getZ(),2));
        return Math.sqrt( xAxis + yAxis + zAxis); 
    }
    
    synchronized public static TraceReader createTraceReader(String traceFileName){
        TraceReader.existsAnInstance = true;    
        return new TraceReader(traceFileName);
    }
    
    synchronized public static boolean wasAlreadyCreatedAnyInstance() {
        return TraceReader.existsAnInstance;
    }
            
    public String respond (String input){
        return input;
    }
}
